795b6f3881fe936b42e1c6a67ffdb320bf818d9f
[strongswan.git] / src / _updown / _updown
1 #! /bin/sh
2 # iproute2 version, default updown script
3 #
4 # Copyright (C) 2003-2004 Nigel Meteringham
5 # Copyright (C) 2003-2004 Tuomo Soini
6 # Copyright (C) 2002-2004 Michael Richardson
7 # Copyright (C) 2005-2007 Andreas Steffen <andreas.steffen@strongswan.org>
8
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of the GNU General Public License as published by the
11 # Free Software Foundation; either version 2 of the License, or (at your
12 # option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
13
14 # This program is distributed in the hope that it will be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
16 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
17 # for more details.
18 #
19 # RCSID $Id: _updown.in,v 1.2 2006/04/17 15:06:29 as Exp $
20
21 # CAUTION:  Installing a new version of strongSwan will install a new
22 # copy of this script, wiping out any custom changes you make.  If
23 # you need changes, make a copy of this under another name, and customize
24 # that, and use the (left/right)updown parameters in ipsec.conf to make
25 # strongSwan use yours instead of this default one.
26
27 # things that this script gets (from ipsec_pluto(8) man page)
28 #
29 #      PLUTO_VERSION
30 #              indicates  what  version of this interface is being
31 #              used.  This document describes version  1.1.   This
32 #              is upwardly compatible with version 1.0.
33 #
34 #       PLUTO_VERB
35 #              specifies the name of the operation to be performed
36 #              (prepare-host, prepare-client, up-host, up-client,
37 #              down-host, or down-client).  If the address family
38 #              for security gateway to security gateway communica¬≠
39 #              tions is IPv6, then a suffix of -v6 is added to the
40 #              verb.
41 #
42 #       PLUTO_CONNECTION
43 #              is the name of the  connection  for  which  we  are
44 #              routing.
45 #
46 #       PLUTO_NEXT_HOP
47 #              is the next hop to which packets bound for the peer
48 #              must be sent.
49 #
50 #       PLUTO_INTERFACE
51 #              is the name of the ipsec interface to be used.
52 #
53 #       PLUTO_REQID
54 #              is the requid of the ESP policy
55 #
56 #       PLUTO_ME
57 #              is the IP address of our host.
58 #
59 #       PLUTO_MY_ID
60 #              is the ID of our host.
61 #
62 #       PLUTO_MY_CLIENT
63 #              is the IP address / count of our client subnet.  If
64 #              the  client  is  just  the  host,  this will be the
65 #              host's own IP address / max (where max  is  32  for
66 #              IPv4 and 128 for IPv6).
67 #
68 #       PLUTO_MY_CLIENT_NET
69 #              is the IP address of our client net.  If the client
70 #              is just the host, this will be the  host's  own  IP
71 #              address.
72 #
73 #       PLUTO_MY_CLIENT_MASK
74 #              is  the  mask for our client net.  If the client is
75 #              just the host, this will be 255.255.255.255.
76 #
77 #       PLUTO_MY_SOURCEIP
78 #              if non-empty, then the source address for the route will be
79 #              set to this IP address.
80 #
81 #       PLUTO_MY_PROTOCOL
82 #              is the IP protocol that will be transported.
83 #
84 #       PLUTO_MY_PORT
85 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
86 #              restricted on our side.
87 #
88 #       PLUTO_PEER
89 #              is the IP address of our peer.
90 #
91 #       PLUTO_PEER_ID
92 #              is the ID of our peer.
93 #
94 #       PLUTO_PEER_CA
95 #              is the CA which issued the cert of our peer.
96 #
97 #       PLUTO_PEER_CLIENT
98 #              is the IP address / count of the peer's client sub¬≠
99 #              net.   If the client is just the peer, this will be
100 #              the peer's own IP address / max (where  max  is  32
101 #              for IPv4 and 128 for IPv6).
102 #
103 #       PLUTO_PEER_CLIENT_NET
104 #              is the IP address of the peer's client net.  If the
105 #              client is just the peer, this will  be  the  peer's
106 #              own IP address.
107 #
108 #       PLUTO_PEER_CLIENT_MASK
109 #              is  the  mask  for  the  peer's client net.  If the
110 #              client   is   just   the   peer,   this   will   be
111 #              255.255.255.255.
112 #
113 #       PLUTO_PEER_PROTOCOL
114 #              is the IP protocol that will be transported.
115 #
116 #       PLUTO_PEER_PORT
117 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
118 #              restricted on the peer side.
119 #
120
121 # uncomment to log VPN connections
122 VPN_LOGGING=1
123 #
124 # tag put in front of each log entry:
125 TAG=vpn
126 #
127 # syslog facility and priority used:
128 FAC_PRIO=local0.notice
129 #
130 # to create a special vpn logging file, put the following line into
131 # the syslog configuration file /etc/syslog.conf:
132 #
133 # local0.notice                   -/var/log/vpn
134 #
135
136 # check interface version
137 case "$PLUTO_VERSION" in
138 1.[0|1])        # Older Pluto?!?  Play it safe, script may be using new features.
139         echo "$0: obsolete interface version \`$PLUTO_VERSION'," >&2
140         echo "$0:       called by obsolete Pluto?" >&2
141         exit 2
142         ;;
143 1.*)    ;;
144 *)      echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
145         exit 2
146         ;;
147 esac
148
149 # check parameter(s)
150 case "$1:$*" in
151 ':')                    # no parameters
152         ;;
153 iptables:iptables)      # due to (left/right)firewall; for default script only
154         ;;
155 custom:*)               # custom parameters (see above CAUTION comment)
156         ;;
157 *)      echo "$0: unknown parameters \`$*'" >&2
158         exit 2
159         ;;
160 esac
161
162 # utility functions for route manipulation
163 # Meddling with this stuff should not be necessary and requires great care.
164 uproute() {
165         doroute add
166         ip route flush cache
167 }
168 downroute() {
169         doroute delete
170         ip route flush cache
171 }
172
173 addsource() {
174         st=0
175         if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local
176         then
177             it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
178             oops="`eval $it 2>&1`"
179             st=$?
180             if test " $oops" = " " -a " $st" != " 0"
181             then
182                 oops="silent error, exit status $st"
183             fi
184             if test " $oops" != " " -o " $st" != " 0"
185             then
186                 echo "$0: addsource \`$it' failed ($oops)" >&2
187             fi
188         fi
189         return $st
190 }
191
192 doroute() {
193         st=0
194
195         if [ -z "$PLUTO_MY_SOURCEIP" ]
196         then
197             if [ -f /etc/sysconfig/defaultsource ]
198             then
199                 . /etc/sysconfig/defaultsource
200             fi
201
202             if [ -f /etc/conf.d/defaultsource ]
203             then
204                 . /etc/conf.d/defaultsource
205             fi
206
207             if [ -n "$DEFAULTSOURCE" ]
208             then
209                 PLUTO_MY_SOURCEIP=$DEFAULTSOURCE
210             fi
211         fi
212
213         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
214         then
215             # leave because no route entry is required
216             return $st
217         fi
218
219         parms1="$PLUTO_PEER_CLIENT"
220
221         parms2=
222         if [ -n "$KLIPS" ]
223         then
224             if [ -n "$PLUTO_NEXT_HOP" ]
225             then
226                 parms2="via $PLUTO_NEXT_HOP"
227             fi
228         else
229             parms2="via $PLUTO_ME"
230         fi      
231         parms2="$parms2 dev $PLUTO_INTERFACE"
232
233         parms3=
234         if test "$1" = "add" -a -n "$PLUTO_MY_SOURCEIP"
235         then
236             addsource
237             parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*}"
238         fi
239
240         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
241         "0.0.0.0/0.0.0.0")
242                 # opportunistic encryption work around
243                 # need to provide route that eclipses default, without 
244                 # replacing it.
245                 it="ip route $1 0.0.0.0/1 $parms2 $parms3 &&
246                         ip route $1 128.0.0.0/1 $parms2 $parms3"
247                 ;;
248         *)      it="ip route $1 $parms1 $parms2 $parms3"
249                 ;;
250         esac
251         oops="`eval $it 2>&1`"
252         st=$?
253         if test " $oops" = " " -a " $st" != " 0"
254         then
255             oops="silent error, exit status $st"
256         fi
257         if test " $oops" != " " -o " $st" != " 0"
258         then
259             echo "$0: doroute \`$it' failed ($oops)" >&2
260         fi
261         return $st
262 }
263  
264 # in the presence of KLIPS and ipsecN interfaces do not use IPSEC_POLICY 
265 if [ `echo "$PLUTO_INTERFACE" | grep "ipsec"` ]
266 then
267         KLIPS=1
268         IPSEC_POLICY_IN=""
269         IPSEC_POLICY_OUT=""
270 else
271         KLIPS=
272         IPSEC_POLICY="-m policy --pol ipsec --proto esp --reqid $PLUTO_REQID"
273         IPSEC_POLICY_IN="$IPSEC_POLICY --dir in"
274         IPSEC_POLICY_OUT="$IPSEC_POLICY --dir out"
275 fi
276
277 # are there port numbers?
278 if [ "$PLUTO_MY_PORT" != 0 ]
279 then
280         S_MY_PORT="--sport $PLUTO_MY_PORT"
281         D_MY_PORT="--dport $PLUTO_MY_PORT"
282 fi
283 if [ "$PLUTO_PEER_PORT" != 0 ]
284 then
285         S_PEER_PORT="--sport $PLUTO_PEER_PORT"
286         D_PEER_PORT="--dport $PLUTO_PEER_PORT"
287 fi
288
289 # the big choice
290 case "$PLUTO_VERB:$1" in
291 prepare-host:*|prepare-client:*)
292         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
293         then
294             # exit because no route will be added,
295             # so that existing routes can stay
296             exit 0
297         fi
298
299         # delete possibly-existing route (preliminary to adding a route)
300         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
301         "0.0.0.0/0.0.0.0")
302                 # need to provide route that eclipses default, without 
303                 # replacing it.
304                 parms1="0.0.0.0/1"
305                 parms2="128.0.0.0/1"
306                 it="ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1"
307                 oops="`ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1`"
308                 ;;
309         *)
310                 parms="$PLUTO_PEER_CLIENT"
311                 it="ip route delete $parms 2>&1"
312                 oops="`ip route delete $parms 2>&1`"
313                 ;;
314         esac
315         status="$?"
316         if test " $oops" = " " -a " $status" != " 0"
317         then
318                 oops="silent error, exit status $status"
319         fi
320         case "$oops" in
321         *'RTNETLINK answers: No such process'*) 
322                 # This is what route (currently -- not documented!) gives
323                 # for "could not find such a route".
324                 oops=
325                 status=0
326                 ;;
327         esac
328         if test " $oops" != " " -o " $status" != " 0"
329         then
330                 echo "$0: \`$it' failed ($oops)" >&2
331         fi
332         exit $status
333         ;;
334 route-host:*|route-client:*)
335         # connection to me or my client subnet being routed
336         uproute
337         ;;
338 unroute-host:*|unroute-client:*)
339         # connection to me or my client subnet being unrouted
340         downroute
341         ;;
342 up-host:)
343         # connection to me coming up
344         # If you are doing a custom version, firewall commands go here.
345         ;;
346 down-host:)
347         # connection to me going down
348         # If you are doing a custom version, firewall commands go here.
349         ;;
350 up-client:)
351         # connection to my client subnet coming up
352         # If you are doing a custom version, firewall commands go here.
353         ;;
354 down-client:)
355         # connection to my client subnet going down
356         # If you are doing a custom version, firewall commands go here.
357         ;;
358 up-host:iptables)
359         # connection to me, with (left/right)firewall=yes, coming up
360         # This is used only by the default updown script, not by your custom
361         # ones, so do not mess with it; see CAUTION comment up at top.
362         iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
363             -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
364             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
365         iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
366             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
367             -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT -j ACCEPT
368         #
369         # log IPsec host connection setup
370         if [ $VPN_LOGGING ]
371         then
372           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
373           then
374             logger -t $TAG -p $FAC_PRIO \
375               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
376           else
377             logger -t $TAG -p $FAC_PRIO \
378               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
379           fi
380         fi      
381         ;;
382 down-host:iptables)
383         # connection to me, with (left/right)firewall=yes, going down
384         # This is used only by the default updown script, not by your custom
385         # ones, so do not mess with it; see CAUTION comment up at top.
386         iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
387             -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
388             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
389         iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
390             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
391             -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT -j ACCEPT
392         #
393         # log IPsec host connection teardown
394         if [ $VPN_LOGGING ]
395         then
396           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
397           then
398             logger -t $TAG -p $FAC_PRIO -- \
399               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
400           else
401             logger -t $TAG -p $FAC_PRIO -- \
402             "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
403           fi
404         fi
405         ;;
406 up-client:iptables)
407         # connection to client subnet, with (left/right)firewall=yes, coming up
408         # This is used only by the default updown script, not by your custom
409         # ones, so do not mess with it; see CAUTION comment up at top.
410         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
411         then
412           iptables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
413               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
414               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
415                  $IPSEC_POLICY_OUT -j ACCEPT
416           iptables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
417               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
418               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
419                  $IPSEC_POLICY_IN -j ACCEPT
420         fi
421         #
422         # a virtual IP requires an INPUT and OUTPUT rule on the host
423         # or sometimes host access via the internal IP is needed
424         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
425         then
426           iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
427               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
428               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
429                  $IPSEC_POLICY_IN -j ACCEPT
430           iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
431               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
432               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
433                  $IPSEC_POLICY_OUT -j ACCEPT
434         fi
435         #
436         # log IPsec client connection setup
437         if [ $VPN_LOGGING ]
438         then
439           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
440           then
441             logger -t $TAG -p $FAC_PRIO \
442               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
443           else
444             logger -t $TAG -p $FAC_PRIO \
445               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
446           fi
447         fi
448         ;;
449 down-client:iptables)
450         # connection to client subnet, with (left/right)firewall=yes, going down
451         # This is used only by the default updown script, not by your custom
452         # ones, so do not mess with it; see CAUTION comment up at top.
453         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
454         then
455           iptables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
456               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
457               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
458                  $IPSEC_POLICY_OUT -j ACCEPT
459           iptables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
460               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
461               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
462                  $IPSEC_POLICY_IN -j ACCEPT
463         fi
464         #
465         # a virtual IP requires an INPUT and OUTPUT rule on the host
466         # or sometimes host access via the internal IP is needed
467         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
468         then
469           iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
470               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
471               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
472                  $IPSEC_POLICY_IN -j ACCEPT
473           iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
474               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
475               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
476                  $IPSEC_POLICY_OUT -j ACCEPT
477         fi
478         #
479         # log IPsec client connection teardown
480         if [ $VPN_LOGGING ]
481         then
482           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
483           then
484             logger -t $TAG -p $FAC_PRIO -- \
485               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
486           else
487             logger -t $TAG -p $FAC_PRIO -- \
488               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
489           fi
490         fi
491         ;;
492 #
493 # IPv6
494 #
495 prepare-host-v6:*|prepare-client-v6:*)
496         ;;
497 route-host-v6:*|route-client-v6:*)
498         # connection to me or my client subnet being routed
499         #uproute_v6
500         ;;
501 unroute-host-v6:*|unroute-client-v6:*)
502         # connection to me or my client subnet being unrouted
503         #downroute_v6
504         ;;
505 up-host-v6:*)
506         # connection to me coming up
507         # If you are doing a custom version, firewall commands go here.
508         ;;
509 down-host-v6:*)
510         # connection to me going down
511         # If you are doing a custom version, firewall commands go here.
512         ;;
513 up-client-v6:)
514         # connection to my client subnet coming up
515         # If you are doing a custom version, firewall commands go here.
516         ;;
517 down-client-v6:)
518         # connection to my client subnet going down
519         # If you are doing a custom version, firewall commands go here.
520         ;;
521 *)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
522         exit 1
523         ;;
524 esac